image: node:12.0-slim

stages:
  - 🧸tests
  - 📝publish

variables:
  SUB_GROUP: "gl-pages"

pages:
  stage: 📝publish
  script:
    - echo "🚀 publishing to production"
    - mkdir -p public/{js,css}
    - cp ./website/js/*.* public/js
    - cp ./website/css/*.* public/css
    - cp ./website/index.html public
    - echo ${CI_PAGES_URL}
  artifacts:
    paths:
      - public
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
  environment:
    name: production/${CI_PROJECT_NAME}/${CI_COMMIT_REF_NAME}
    url: https://${CI_PROJECT_ROOT_NAMESPACE}.gitlab.io/${SUB_GROUP}/${CI_PROJECT_NAME}

💣testing:
  stage: 🧸tests
  image: registry.gitlab.com/tanuki-workshops/gl-pages/images/ci-tools/testing:latest
  rules:
    - if: $CI_MERGE_REQUEST_IID
  artifacts:
    reports:
      junit: test-results.xml
    paths: 
      - test-results.xml # keep the report
    expire_in: 1 week
  script: |
    mocha test.js --reporter mocha-junit-reporter
    cat ./test-results.xml

🤔pages:preview:
  stage: 📝publish
  script:
    - echo "🎲 publishing for preview"
    - mkdir -p public/{js,css}
    - cp ./website/js/*.* public/js
    - cp ./website/css/*.* public/css
    - cp ./website/index.html public
    - echo ${CI_PAGES_URL}
  artifacts:
    paths:
      - public
  rules:
    - if: $CI_MERGE_REQUEST_IID
  environment:
    name: preview/${CI_PROJECT_NAME}/${CI_COMMIT_REF_NAME}
    url: https://${CI_PROJECT_ROOT_NAMESPACE}.gitlab.io/-/${SUB_GROUP}/${CI_PROJECT_NAME}/-/jobs/${CI_JOB_ID}/artifacts/public/index.html
    on_stop: 😢pages:preview:stop

😢pages:preview:stop:
  stage: 📝publish
  rules:
    - if: $CI_MERGE_REQUEST_IID
      when: manual
  allow_failure: true 
  environment:
    name: preview/${CI_PROJECT_NAME}/${CI_COMMIT_REF_NAME}
    action: stop
  script:
    - echo "👋 bye"




